* ----------------------------------------------------------- Begin GetF_Out
      subroutine GetF_Out(f_in, ext_nu, string, insert, 
     :                    ipos, f_out)

* Create the output file name.

* - If ext_nu .ne. ' ' .and. ext_nu .ne. 'XXX', replaces input extension 
*   with ext_nu
* - Either inserts or overwrites string_c at position ipos
* - Note that if inserted, it is inserted to the left of the indicated 
* position.  Here are some examples:
*      ipos     inserted where?
*       0          to left of period
*      -1          to left of stem character next to period
*      +1          to left of first character of extension (note
*                  that the extension will always be <= 3 characters, so
*                  inserting in the extension will push characters off the end.
*                  Likewise, the stem is always <= 8 characters, so inserting
*                  can push characters off the end of the stem.


* Dates: 11/07/01 - Written by D. Boore

      character f_in*(*), ext_nu*(*), string*(*), f_out*(*) 
      character ext_in*3, ext_nu_upper*3
      character stem*20, stem_in*8, ext*10

      logical insert

      call trim_c(f_in,nc_f_in)
      call trim_c(string, nc_string)
      call trim_c(ext_nu,nc_ext_nu)
      ext_nu_upper = ' '
      if (nc_ext_nu .ne. 0) then
        ext_nu_upper = ext_nu(1:nc_ext_nu)
        call trim_c(ext_nu_upper,nc_ext_nu_upper)
        call upstr(ext_nu_upper)
      end if

      indp = index(f_in,'.')
      stem_in = ' '
      stem_in = f_in(1:indp-1)
      call trim_c(stem_in,nc_stem_in)
      ext_in = ' '
      ext_in = f_in(indp+1:nc_f_in)
      call trim_c(ext_in, nc_ext_in)

      stem = ' '
      stem = stem_in
      nc_stem = nc_stem_in

      ext = ' '
      ext = ext_in
      nc_ext = nc_ext_in

* Check if new extension is to be used:      
      if(ext_nu_upper .ne. ' ' .and. ext_nu_upper .ne. 'XXX') then
        ext = ext_nu(1:nc_ext_nu)
        call trim_c(ext,nc_ext)
* Have to reset ext_in; it could have changed length
        ext_in = ' '
        ext_in = ext        
        call trim_c(ext_in,nc_ext_in)
      end if

* Insert or overwrite string if nonzero length
      if (nc_string .ne. 0) then  ! Not finished
        if (nc_stem_in + ipos .lt. 0) ipos = -nc_stem_in !reset to 1rst ch
        if (.not. insert) then  ! overwrite
          if (ipos .le. 0) then  ! work on stem
            stem(nc_stem_in+ipos+1:nc_stem_in+ipos+nc_string) = 
     :        string(1:nc_string)
          else ! work on extension
            ext(ipos:ipos+nc_string-1) = string(1:nc_string)
          end if
        else  ! insert
          if (ipos .le. 0) then  ! work on stem
            if (nc_stem_in+ipos .gt. 0)  ! some original to left of insert
     :      stem(1:nc_stem_in+ipos) = stem_in(1:nc_stem_in+ipos)
            stem(nc_stem_in+ipos+1:nc_stem_in+ipos+nc_string) = 
     :        string(1:nc_string)
            if (ipos .lt. 0)             ! some original to right of insert
     :      stem(nc_stem_in+ipos+nc_string+1:nc_stem_in+nc_string) =
     :        stem_in(nc_stem_in+ipos+1:nc_stem_in)
          else ! work on extension
            if (ipos-1 .gt. 0)           ! some original to left of insert
     :      ext(1:ipos-1) = ext_in(1:ipos-1)
            ext(ipos:ipos+nc_string-1)= string(1:nc_string)
            if (ipos .lt. nc_ext_in)
     :      ext(ipos+nc_string:nc_string+nc_ext_in) = 
     :        ext_in(ipos:nc_ext_in)     ! some original to right of insert
          end if
        end if
      end if

      call trim_c(stem,nc_stem)
      call trim_c(ext,nc_ext)
      indstem = min0(nc_stem,8)
      indext  = min0(nc_ext,3)
      f_out = stem(1:indstem)//'.'//ext(1:indext)
      call trim_c(f_out,nc_f_out)
      if (f_out(1:nc_f_out) .eq. f_in(1:nc_f_in)) then
        write(*,'(a)') '  Warning, no change in filename, so '//
     :                   'f_out = xxxxxxxx.xxx'
         f_out = 'xxxxxxxx.xxx'
      end if

      return
      end

* ----------------------------------------------------------- End GetF_Out
