      subroutine mak_stem(tag, t, stem)

* COnstructs a stem name (stem) by appending up to 4 characters of tag with
* a 4-character string giving the period t:
* e.g., t = .001 => "p001"
*       t = 0.01 => "p010"
*       t = 9.99 => "9p99"
*       t = 99.9 => "99p9"
*       t = 500.4=> "500p"
* (note that 999.9 will give "***p")

* Needs subroutine trim_c

* Dates: 11/03/00 - Written by D.Boore

      character tag*(*), stem*(*)  ! stem should be character stem*8
      character buf*4

      buf = ' '
      if (t .ge. 100.0) then
        int_t = int(aint(1.0 * t))
        write(buf(1:3),'(i3.3)') int_t
        buf(4:4) = 'p'
      else if (t .ge. 10.0) then
        t_trunc = aint(10.0 * t)/10.0
        write(buf(1:4),'(f4.1)') t_trunc
        buf(3:3) = 'p'
      else if (t .ge. 1.00) then
        t_trunc = aint(100.0 * t)/100.0
        write(buf(1:4),'(f4.2)') t_trunc
        buf(2:2) = 'p'
      else
        int_t = int(aint(1000.0 * t))
        write(buf(2:4),'(i3.3)') int_t
        buf(1:1) = 'p'
      end if

      call trim_c(tag, nc_tag)

      if (nc_tag .gt. 4) nc_tag = 4

      stem = ' '
      stem = tag(1:nc_tag)//buf

      return
      end


