      module byte_swaps

! Dates: 04/22/09 - Written by Chris Stephens

        implicit none

        contains

! swap 2-byte integer

        INTEGER(KIND=2) function i2swap(i)

        INTEGER(KIND=2), INTENT(IN)	:: i

	i2swap = i

        call mvbits(i,0,8,i2swap,8)
        call mvbits(i,8,8,i2swap,0)

        return
        end function i2swap

! swap 4-byte integer

        INTEGER(KIND=4) function i4swap(i)

        INTEGER(KIND=4), INTENT(IN)	:: i

        i4swap = i

        call mvbits(i, 0,8,i4swap,24)
        call mvbits(i, 8,8,i4swap,16)
        call mvbits(i,16,8,i4swap, 8)
        call mvbits(i,24,8,i4swap, 0)

        return
        end function i4swap

! byte and word swap for real

        REAL(KIND=4) function r4swap(r)

        REAL(KIND=4), INTENT(IN)	:: r

        INTEGER(KIND=KIND(r))          :: i
        INTEGER(KIND=KIND(r))          :: iswap

        i = TRANSFER(r,i)

        call mvbits(i, 0,8,iswap,24)
        call mvbits(i, 8,8,iswap,16)
        call mvbits(i,16,8,iswap, 8)
        call mvbits(i,24,8,iswap, 0)

        r4swap = TRANSFER(iswap,r4swap)

        return
        end function r4swap

      end module byte_swaps
