* -------------------------- BEGIN SMOOTH_LOGBOX --------------------------
      subroutine Smooth_LogBox (y, npts, smooth_param)


! **** WARNING:  This is a non-maintained version; see SMOOTH_INTERPOLATE
! **** for the most recent code.

* SMOOTHING OVER LOGARITHMICALLY SPACED FREQUENCIES
* itype = 3: Box
*   smooth_param = xi, which is the fraction of a decade spanned by the
*                  width of the box smoothing function.


* Dates:  06/18/07 - Written by D. Boore, patterned after smooth_n.for

      real y(*)
      real work(:)
      allocatable :: work
      
      pi = 4.0*atan(1.0)

      allocate(work(npts))
      
      do i = 1, npts
        work(i) = y(i)
      end do
      
      ic1 = nint(10.0**(0.5*smooth_param))
      ic2 = nint(float(npts)*10.0**(-0.5*smooth_param))
      
      do ic = 1, ic1

        iz1 = 1
        iz2 = nint(float(ic)*10.0**(0.5*smooth_param))
        
        sum = 0.0
         
        do j = iz1, iz2
          sum = sum + work(j)      
        end do
        
        y(ic) = sum/float(iz2-iz1+1)

      end do
      
      
      do ic = ic1+1, ic2-1
      
        iz1 = nint(float(ic)*10.0**(-0.5*smooth_param))
        iz2 = nint(float(ic)*10.0**(0.5*smooth_param))
        
        sum = 0.0
         
        do j = iz1, iz2
          sum = sum + work(j)
        end do
        
        y(ic) = sum/float(iz2-iz1+1)

      
      end do
      
      
      do ic = ic2, npts
      
      
        iz1 = nint(float(ic)*10.0**(-0.5*smooth_param))
        iz2 = npts
        
        sum = 0.0
         
        do j = iz1, iz2
          sum = sum + work(j)
        end do
        
        y(ic) = sum/float(iz2-iz1+1)

      end do
      
      

      deallocate(work)

      return
      end
* -------------------------- END Smooth_LogBox --------------------------

 